#  RPM build options:
#
#  --without-binsuffix -- Do not name executable "python2".
#  --without-tkinter -- Do not build Tkinter package.
#  --with-pymalloc -- Enable pymalloc memory allocator (may break Zope).
#  --with-idlesuffix -- Install idle as "idle2".
#  --without-lfs -- Enable Large File Support.
#
#################################
#  End of user-modifiable configs
#################################

%define name python
%define version 2.1.1
%define release 3
%define __prefix /usr

#  these implement the logic that enable the "--with[out]" above.
%define tmp_binsuffix 2
%{?_without_binsuffix: %{expand: %%define tmp_binsuffix none}}
%define config_binsuffix %(if [ "%{tmp_binsuffix}" = none ]; then echo ; else echo "%{tmp_binsuffix}"; fi)

%define tmp_idlesuffix none
%{?_with_idlesuffix: %{expand: %%define tmp_idlesuffix 2}}
%define config_idlesuffix %(if [ "%{tmp_idlesuffix}" = none ]; then echo ; else echo "%{tmp_idlesuffix}"; fi)

%define config_tkinter 1
%{?_without_tkinter: %{expand: %%define config_tkinter 0}}

%define config_pymalloc --without-pymalloc
%{?_with_pymalloc: %{expand: %%define config_pymalloc --with-pymalloc}}

%define config_lfs 1
%{?_without_lfs: %{expand: %%define config_lfs 0}}

Summary: An interpreted, interactive, object-oriented programming language.
Name: %{name}%{config_binsuffix}
Version: %{version}
Release: %{release}
Copyright: Modified CNRI Open Source License
Group: Development/Languages
Source: Python-%{version}.tgz
Patch0: Python-2.1-build.patch
Patch1: Python-2.1-pythonpath.patch
Patch2: Python-2.1-expat.patch
Patch3: Python-2.1-lfs.patch
BuildRoot: /var/tmp/%{name}-%{version}-root
BuildPrereq: expat-devel >= 1.1-3tummy
BuildPrereq: db1-devel
BuildPrereq: gdbm-devel
Prefix: %{__prefix}
Packager: Sean Reifschneider <jafo-rpms@tummy.com>

%description
Python is an interpreted, interactive, object-oriented programming
language.  It incorporates modules, exceptions, dynamic typing, very high
level dynamic data types, and classes. Python combines remarkable power
with very clear syntax. It has interfaces to many system calls and
libraries, as well as to various window systems, and is extensible in C or
C++. It is also usable as an extension language for applications that need
a programmable interface.  Finally, Python is portable: it runs on many
brands of UNIX, on PCs under Windows, MS-DOS, and OS/2, and on the
Mac.

%package devel
Summary: The libraries and header files needed for Python extension development.
Requires: python%{config_binsuffix} = %{PACKAGE_VERSION}
Group: Development/Libraries

%description devel
The Python programming language's interpreter can be extended with
dynamically loaded extensions and can be embedded in other programs.
This package contains the header files and libraries needed to do
these types of tasks.

Install python-devel if you want to develop Python extensions.  The
python package will also need to be installed.  You'll probably also
want to install the python-docs package, which contains Python
documentation.

%if %{config_tkinter}
%package tkinter
Summary: A graphical user interface for the Python scripting language.
Group: Development/Languages
Requires: python%{config_binsuffix} = %{PACKAGE_VERSION}-%{release}

%description tkinter
The Tkinter (Tk interface) program is an graphical user interface for
the Python scripting language.

You should install the tkinter package if you'd like to use a graphical
user interface for Python programming.
%endif

%package tools
Summary: A collection of development tools included with Python.
Group: Development/Tools
Requires: python%{config_binsuffix} = %{PACKAGE_VERSION}-%{release}

%description tools
The Python package includes several development tools that are used
to build python programs.  This package contains a selection of those
tools, including the IDLE Python IDE.

Install python-tools if you want to use these tools to develop
Python programs.  You will also need to install the python and
tkinter packages.

%changelog"
* Wed Aug 23 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1.1-3]
- Fixing some issues found in the testing of the last release with the
  new configuration directives.

* Wed Aug 20 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1.1-2]
- Adding LFS support.
- Changed configurable options to use "--with[out]" on build line.

* Wed Jul 25 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1.1-1]
- Updated to 2.1.1 release.

* Thu Jun 16 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1-6]
- Added spec file configuration to add a suffix to the IDLE command.
  (Thanks to Russell Stuart)

* Thu Jun 7 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1-5]
- Added entry to disable building tkinter.  (Mentioned by Msquared)
- Added gdbm-devel build pre-req.  (Thanks to Pat Callahan)
- Added db1-devel build pre-req.  (Thanks to Pat Callahan)
- Changed expat build pre-req to expat-devel.  (Thanks to Pat Callahan)
- Ugh, can't have spaces in defattr.  (Thanks to Pat Callahan)

* Sat Apr 21 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1-4]
- Added more "defattr" entries for the files sections.
- Ugh, the .so files were lost in the last package.
- Fixed IDLE.

* Sat Apr 21 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1-3]
- pymalloc wasn't properly getting disabled.  Not sure how rpm is picking up
  commented-out %define directives, but that's what it was doing.  Ugh.
- Made a similar change for binsuffix.
- Adding a "tools" sub-package.

* Tue Apr 17 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1-2tummy]
- Removed --with-pymalloc in configure.  Apparently threaded programs like
   Zope have problems with this.  Thanks for pointing that out, Guido.

* Tue Apr 17 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1-1tummy]
- Updated to the 2.1 final release.

* Mon Apr 16 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1c1-2tummy]
- Fixed naming to "python2" instead of "python2.1".
- Fixing up path in pydoc if binsuffix is set.

* Sun Apr 15 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1c1-1tummy]
- Upgraded to 2.1c1
- Changed package name to "python2" if building /usr/bin/python2
- Changed binary suffix to "2" instead of "2.1", in preperation for final
  release.

* Fri Mar 23 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1b2-1tummy]
- Upgraded to 2.1b2
- Enabled --with-pymalloc

* Tue Mar  6 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1b1-1tummy]
- Upgraded to 2.1b1

* Thu Feb 15 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1a2-2tummy]
- Tony Seward sent a patch to fix the expat module's header path in setup.py.

* Sat Feb 3 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1a2-1tummy]
- Updated to 2.1a2.

* Wed Jan 25 2001 Sean Reifschneider <jafo-rpms@tummy.com>
[Release 2.1a1-1tummy]
- Release for 2.1a1
- Splitting out devel and tk packages.

#######
#  PREP
#######
%prep
%setup -n Python-%{version}
%patch0
%patch1 -p1
%patch2
%if %{config_lfs}
%patch3 -p1
%endif

########
#  BUILD
########
%build
#  enable LFS
%if %{config_lfs}
   CFLAGS="`getconf LFS_CFLAGS` -DHAVE_LARGEFILE_SUPPORT"
   export CFLAGS
   OPT="-g -O2 $CFLAGS"
   export OPT
%endif

./configure %{config_pymalloc} --prefix=%{__prefix}
make

##########
#  INSTALL
##########
%install
#  set the install path
echo '[install_scripts]' >setup.cfg
echo 'install_dir='"${RPM_BUILD_ROOT}/usr/bin" >>setup.cfg

[ -d "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{__prefix}/lib/python2.1/lib-dynload
make prefix=$RPM_BUILD_ROOT%{__prefix} install
[ ! -z "%{config_binsuffix}" ] && ( cd $RPM_BUILD_ROOT%{__prefix}/bin; mv -f python python"%{config_binsuffix}" )
[ ! -z "%{config_binsuffix}" ] && ( cd $RPM_BUILD_ROOT%{__prefix}/man/man1; mv python.1 python%{config_binsuffix}.1 )

#  REPLACE PATH IN PYDOC
if [ ! -z "%{config_binsuffix}" ]
then
   (
      cd $RPM_BUILD_ROOT%{__prefix}/bin
      mv pydoc pydoc.old
      sed 's|#!/usr/bin/env python|#!/usr/bin/env python'%{config_binsuffix}'|' \
            pydoc.old >pydoc
      chmod 755 pydoc
      rm -f pydoc.old
   )
fi

########
#  Tools
echo '#!/bin/bash' >${RPM_BUILD_ROOT}%{_bindir}/idle%{config_idlesuffix}
echo 'exec %{_prefix}/bin/python%{config_binsuffix} /usr/lib/python2.1/Tools/idle/idle.py' >>${RPM_BUILD_ROOT}%{_bindir}/idle%{config_idlesuffix}
chmod 755 ${RPM_BUILD_ROOT}%{_bindir}/idle%{config_idlesuffix}
cp -a Tools ${RPM_BUILD_ROOT}%{_prefix}/lib/python2.1

#  MAKE FILE LISTS
rm -f mainpkg.files
find "$RPM_BUILD_ROOT""%{__prefix}"/lib/python2.1/lib-dynload -type f |
	sed "s|^${RPM_BUILD_ROOT}|/|" |
	grep -v -e '_tkinter.so$' >mainpkg.files
find "$RPM_BUILD_ROOT""%{__prefix}"/bin -type f |
	sed "s|^${RPM_BUILD_ROOT}|/|" |
	grep -v -e '/bin/idle%{config_idlesuffix}$' >>mainpkg.files

rm -f tools.files
find "$RPM_BUILD_ROOT""%{__prefix}"/lib/python2.1/Tools -type f |
	sed "s|^${RPM_BUILD_ROOT}|/|" >tools.files
echo "%{__prefix}"/bin/idle%{config_idlesuffix} >>tools.files


########
#  CLEAN
########
%clean
rm -fr $RPM_BUILD_ROOT
rm -f mainpkg.files tools.files

########
#  FILES
########
%files -f mainpkg.files
%defattr(-,root,root)
%{__prefix}/man/man1/python%{config_binsuffix}.1.gz
%doc Misc/README Misc/HYPE Misc/cheatsheet Misc/unicode.txt Misc/Porting
%doc LICENSE Misc/ACKS Misc/BLURB.* Misc/HISTORY Misc/NEWS

%dir %{__prefix}/include/python2.1
%dir %{__prefix}/lib/python2.1/
%{__prefix}/lib/python2.1/*.py*
%{__prefix}/lib/python2.1/pdb.doc
%{__prefix}/lib/python2.1/profile.doc
%{__prefix}/lib/python2.1/curses
%{__prefix}/lib/python2.1/distutils
%{__prefix}/lib/python2.1/encodings
%dir %{__prefix}/lib/python2.1/lib-old
%{__prefix}/lib/python2.1/plat-linux2
%{__prefix}/lib/python2.1/site-packages
%{__prefix}/lib/python2.1/test
%{__prefix}/lib/python2.1/xml

%files devel
%defattr(-,root,root)
%{__prefix}/include/python2.1/*.h
%{__prefix}/lib/python2.1/config

%if %{config_tkinter}
%files tkinter
%defattr(-,root,root)
%{__prefix}/lib/python2.1/lib-tk
%{__prefix}/lib/python2.1/lib-dynload/_tkinter.so*
%endif

%files -f tools.files tools
%defattr(-,root,root)
